<?php

namespace App\Http\Controllers\Admin;

use App\Models\VendorModel;
use App\Models\ProductModel;
use App\Models\OrderModel;
use App\Models\OrderProductsModel;
use DB;

use App\Http\Controllers\Controller;
use SebastianBergmann\CodeCoverage\Report\Html\Dashboard;

class DashboardController extends Controller
{
    private function getFirstLastDate($date){
        $datefrom = date("Y-m", strtotime($date))."-01";
        $dateto = date("Y-m-t", strtotime($date));
        
        return [$datefrom, $dateto];
    }
            
    /**
     * Display the dashboard.
     *
     * @return \Illuminate\Contracts\View\View
     */
    public function dashboard()
    {
        if (!get_user_permission('dashboard', 'r')) {
            return redirect()->route('admin.restricted_page');
        }

        $page_heading = "Dashboard";
        
        return view('admin.dashboard', compact('page_heading'));
    }
    function getLastNDays($days, $format = 'd/m')
    {
        $m = gmdate("m");
        $de = gmdate("d");
        $y = gmdate("Y");
        $dateArray = array();
        for ($i = 0; $i <= $days - 1; $i++) {
            $dateArray[] =  gmdate($format, mktime(0, 0, 0, $m, ($de - $i), $y));
        }
        return array_reverse($dateArray);
    }
}
