<?php

use App\Http\Middleware\IsAdmin;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Artisan;


Route::get('/clear', function () {
    Artisan::call('optimize');
    Artisan::call('optimize:clear');
    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('config:cache');
    Artisan::call('view:clear');
    dd('cleared');
});



Route::get('/admin', 'App\Http\Controllers\admin\LoginController@login')->name('admin.login');
Route::post('admin/check_login', 'App\Http\Controllers\admin\LoginController@check_login')->name('admin.check_login');


// ------------ Admin Routes -------------

Route::namespace('App\Http\Controllers\admin')->prefix('admin')->middleware('admin')->name('admin.')->group(function () {

    Route::get('access-restricted', 'AdminUserController@access_restricted')->name('restricted_page');
    Route::get('dashboard', 'DashboardController@dashboard')->name('dashboard');
    Route::get('change-password', 'AdminController@changePassword')->name('change.password');
    Route::post('change-password', 'AdminController@changePasswordSave')->name('change.password.save');
    Route::get('logout', 'LoginController@logout')->name('logout');

    Route::match(array('GET', 'POST'), 'change_password', 'UsersController@change_password');
    Route::match(array('GET', 'POST'), 'change_user_password', 'UsersController@change_user_password');

});


// ------------ Vendor Main Routes -------------

Route::get('/vendor', 'App\Http\Controllers\vendor\LoginController@login')->name('vendor.login');
Route::post('vendor/check_login', 'App\Http\Controllers\vendor\LoginController@check_login')->name('vendor.check_login');
Route::get('/forgot-password', 'App\Http\Controllers\vendor\LoginController@forgotpassword')->name('vendor.forgot');
Route::post('vendor/check_user', 'App\Http\Controllers\vendor\LoginController@check_user')->name('vendor.check_user');


// ------------ Vendor Sub Routes -------------


Route::namespace('App\Http\Controllers\vendor')->prefix('vendor')->middleware('vendor')->name('vendor.')->group(function () {

    Route::get('logout', 'LoginController@logout')->name('logout');

    // If vendor is verified
    Route::middleware('is_vendor_verified')->group(function () {

        Route::match(array('GET', 'POST'), 'change_password', 'UsersController@change_password');
        Route::get('dashboard', 'DashboardController@dashboard')->name('dashboard');

    });

});

// ----------------------------------

Route::get('/', function () {
    return view('welcome');
});
